<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;base&#x2F;icecap-failure&#x2F;derive&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../icecap_failure_derive/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
</pre><pre class="rust"><code><span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">proc_macro2</span>;
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">syn</span>;

<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">synstructure</span>;
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">quote</span>;

<span class="kw">use</span> <span class="ident">proc_macro2</span>::{<span class="ident">TokenStream</span>, <span class="ident">Span</span>};
<span class="kw">use</span> <span class="ident">syn::LitStr</span>;
<span class="kw">use</span> <span class="ident">syn::spanned::Spanned</span>;

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">struct</span> <span class="ident">Error</span>(<span class="ident">TokenStream</span>);

<span class="kw">impl</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">span</span>: <span class="ident">Span</span>, <span class="ident">message</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Error</span> {
        <span class="ident">Error</span>(<span class="macro">quote_spanned!</span> { <span class="ident">span</span> <span class="op">=</span><span class="op">&gt;</span>
            <span class="macro">compile_error!</span>(#<span class="ident">message</span>);
        })
    }

    <span class="kw">fn</span> <span class="ident">into_tokens</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">TokenStream</span> {
        <span class="self">self</span>.<span class="number">0</span>
    }
}

<span class="kw">impl</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">syn::Error</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">e</span>: <span class="ident">syn::Error</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Error</span> {
        <span class="ident">Error</span>(<span class="ident">e</span>.<span class="ident">to_compile_error</span>())
    }
}

<span class="macro">decl_derive!</span>([<span class="ident">Fail</span>, <span class="ident">attributes</span>(<span class="ident">fail</span>, <span class="ident">cause</span>)] <span class="op">=</span><span class="op">&gt;</span> <span class="ident">fail_derive</span>);

<span class="kw">fn</span> <span class="ident">fail_derive</span>(<span class="ident">s</span>: <span class="ident">synstructure::Structure</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">TokenStream</span> {
    <span class="kw">match</span> <span class="ident">fail_derive_impl</span>(<span class="ident">s</span>) {
        <span class="prelude-val">Err</span>(<span class="ident">err</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">err</span>.<span class="ident">into_tokens</span>(),
        <span class="prelude-val">Ok</span>(<span class="ident">tokens</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">tokens</span>,
    }
}

<span class="kw">fn</span> <span class="ident">fail_derive_impl</span>(<span class="ident">s</span>: <span class="ident">synstructure::Structure</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">TokenStream</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">make_dyn</span> <span class="op">=</span> <span class="macro">quote!</span> { <span class="kw-2">&amp;</span><span class="kw">dyn</span> };
    <span class="kw">let</span> <span class="ident">ty_name</span> <span class="op">=</span> <span class="ident">LitStr::new</span>(<span class="kw-2">&amp;</span><span class="ident">s</span>.<span class="ident">ast</span>().<span class="ident">ident</span>.<span class="ident">to_string</span>(), <span class="ident">Span::call_site</span>());

    <span class="kw">let</span> <span class="ident">cause_body</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">each_variant</span>(<span class="op">|</span><span class="ident">v</span><span class="op">|</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">cause</span>) <span class="op">=</span> <span class="ident">v</span>.<span class="ident">bindings</span>().<span class="ident">iter</span>().<span class="ident">find</span>(<span class="ident">is_cause</span>) {
            <span class="macro">quote!</span>(<span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">::icecap_failure::AsFail::as_fail</span>(#<span class="ident">cause</span>)))
        } <span class="kw">else</span> {
            <span class="macro">quote!</span>(<span class="kw">return</span> <span class="prelude-val">None</span>)
        }
    });

    <span class="kw">let</span> <span class="ident">bt_body</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">each_variant</span>(<span class="op">|</span><span class="ident">v</span><span class="op">|</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">bi</span>) <span class="op">=</span> <span class="ident">v</span>.<span class="ident">bindings</span>().<span class="ident">iter</span>().<span class="ident">find</span>(<span class="ident">is_backtrace</span>) {
            <span class="macro">quote!</span>(<span class="kw">return</span> <span class="prelude-val">Some</span>(#<span class="ident">bi</span>))
        } <span class="kw">else</span> {
            <span class="macro">quote!</span>(<span class="kw">return</span> <span class="prelude-val">None</span>)
        }
    });

    <span class="kw">let</span> <span class="ident">fail</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">unbound_impl</span>(
        <span class="macro">quote!</span>(<span class="ident">::icecap_failure::Fail</span>),
        <span class="macro">quote!</span> {
            <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span> {
                <span class="prelude-val">Some</span>(<span class="macro">concat!</span>(<span class="macro">module_path!</span>(), <span class="string">&quot;::&quot;</span>, #<span class="ident">ty_name</span>))
            }

            <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unreachable_code</span>)]</span>
            <span class="kw">fn</span> <span class="ident">cause</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">::core::option::Option</span><span class="op">&lt;</span>#<span class="ident">make_dyn</span>(<span class="ident">::icecap_failure::Fail</span>)<span class="op">&gt;</span> {
                <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> { #<span class="ident">cause_body</span> }
                <span class="prelude-val">None</span>
            }

            <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unreachable_code</span>)]</span>
            <span class="kw">fn</span> <span class="ident">backtrace</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">::core::option::Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">::icecap_failure::Backtrace</span><span class="op">&gt;</span> {
                <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> { #<span class="ident">bt_body</span> }
                <span class="prelude-val">None</span>
            }
        },
    );
    <span class="kw">let</span> <span class="ident">display</span> <span class="op">=</span> <span class="ident">display_body</span>(<span class="kw-2">&amp;</span><span class="ident">s</span>)<span class="question-mark">?</span>.<span class="ident">map</span>(<span class="op">|</span><span class="ident">display_body</span><span class="op">|</span> {
        <span class="ident">s</span>.<span class="ident">unbound_impl</span>(
            <span class="macro">quote!</span>(<span class="ident">::core::fmt::Display</span>),
            <span class="macro">quote!</span> {
                <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unreachable_code</span>)]</span>
                <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">::core::fmt::Formatter</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">::core::fmt::Result</span> {
                    <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> { #<span class="ident">display_body</span> }
                    <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;An error has occurred.&quot;</span>)
                }
            },
        )
    });

    <span class="prelude-val">Ok</span>(<span class="macro">quote!</span> {
        #<span class="ident">fail</span>
        #<span class="ident">display</span>
    })
}

<span class="kw">fn</span> <span class="ident">display_body</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">synstructure::Structure</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">TokenStream</span><span class="op">&gt;</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">msgs</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">variants</span>().<span class="ident">iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">v</span><span class="op">|</span> <span class="ident">find_error_msg</span>(<span class="kw-2">&amp;</span><span class="ident">v</span>.<span class="ident">ast</span>().<span class="ident">attrs</span>));
    <span class="kw">if</span> <span class="ident">msgs</span>.<span class="ident">all</span>(<span class="op">|</span><span class="ident">msg</span><span class="op">|</span> <span class="ident">msg</span>.<span class="ident">map</span>(<span class="op">|</span><span class="ident">m</span><span class="op">|</span> <span class="ident">m</span>.<span class="ident">is_none</span>()).<span class="ident">unwrap_or</span>(<span class="bool-val">true</span>)) {
        <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>);
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">tokens</span> <span class="op">=</span> <span class="ident">TokenStream::new</span>();
    <span class="kw">for</span> <span class="ident">v</span> <span class="kw">in</span> <span class="ident">s</span>.<span class="ident">variants</span>() {
        <span class="kw">let</span> <span class="ident">msg</span> <span class="op">=</span>
            <span class="ident">find_error_msg</span>(<span class="kw-2">&amp;</span><span class="ident">v</span>.<span class="ident">ast</span>().<span class="ident">attrs</span>)<span class="question-mark">?</span>
              .<span class="ident">ok_or_else</span>(<span class="op">|</span><span class="op">|</span> <span class="ident">Error::new</span>(
                  <span class="ident">v</span>.<span class="ident">ast</span>().<span class="ident">ident</span>.<span class="ident">span</span>(),
                  <span class="string">&quot;All variants must have display attribute.&quot;</span>
              ))<span class="question-mark">?</span>;
        <span class="kw">if</span> <span class="ident">msg</span>.<span class="ident">nested</span>.<span class="ident">is_empty</span>() {
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::new</span>(
                <span class="ident">msg</span>.<span class="ident">span</span>(),
                <span class="string">&quot;Expected at least one argument to fail attribute&quot;</span>
            ));
        }

        <span class="kw">let</span> <span class="ident">format_string</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">msg</span>.<span class="ident">nested</span>[<span class="number">0</span>] {
            <span class="ident">syn::NestedMeta::Meta</span>(<span class="ident">syn::Meta::NameValue</span>(<span class="kw-2">ref</span> <span class="ident">nv</span>)) <span class="kw">if</span> <span class="ident">nv</span>.<span class="ident">path</span>.<span class="ident">is_ident</span>(<span class="string">&quot;display&quot;</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="ident">nv</span>.<span class="ident">lit</span>.<span class="ident">clone</span>()
            }
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::new</span>(
                    <span class="ident">msg</span>.<span class="ident">span</span>(),
                    <span class="string">&quot;Fail attribute must begin `display = \&quot;\&quot;` to control the Display message.&quot;</span>
                ));
            }
        };
        <span class="kw">let</span> <span class="ident">args</span> <span class="op">=</span> <span class="ident">msg</span>.<span class="ident">nested</span>.<span class="ident">iter</span>().<span class="ident">skip</span>(<span class="number">1</span>).<span class="ident">map</span>(<span class="op">|</span><span class="ident">arg</span><span class="op">|</span> <span class="kw">match</span> <span class="kw-2">*</span><span class="ident">arg</span> {
            <span class="ident">syn::NestedMeta::Lit</span>(<span class="ident">syn::Lit::Int</span>(<span class="kw-2">ref</span> <span class="ident">i</span>)) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">let</span> <span class="ident">bi</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">v</span>.<span class="ident">bindings</span>()[<span class="ident">i</span>.<span class="ident">base10_parse</span>::<span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>()<span class="question-mark">?</span>];
                <span class="prelude-val">Ok</span>(<span class="macro">quote!</span>(#<span class="ident">bi</span>))
            }
            <span class="ident">syn::NestedMeta::Meta</span>(<span class="ident">syn::Meta::Path</span>(<span class="kw-2">ref</span> <span class="ident">path</span>)) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">let</span> <span class="ident">id_s</span> <span class="op">=</span> <span class="ident">path</span>.<span class="ident">get_ident</span>().<span class="ident">map</span>(<span class="ident">syn::Ident::to_string</span>).<span class="ident">unwrap_or</span>(<span class="string">&quot;&quot;</span>.<span class="ident">to_string</span>());
                <span class="kw">if</span> <span class="ident">id_s</span>.<span class="ident">starts_with</span>(<span class="string">&quot;_&quot;</span>) {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="ident">idx</span>) <span class="op">=</span> <span class="ident">id_s</span>[<span class="number">1</span>..].<span class="ident">parse</span>::<span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>() {
                        <span class="kw">let</span> <span class="ident">bi</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">v</span>.<span class="ident">bindings</span>().<span class="ident">get</span>(<span class="ident">idx</span>) {
                            <span class="prelude-val">Some</span>(<span class="ident">bi</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">bi</span>,
                            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> {
                                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::new</span>(
                                    <span class="ident">arg</span>.<span class="ident">span</span>(),
                                    <span class="kw-2">&amp;</span><span class="macro">format!</span>(
                                        <span class="string">&quot;display attempted to access field `{}` in `{}::{}` which \
                                     does not exist (there are {} field{})&quot;</span>,
                                        <span class="ident">idx</span>,
                                        <span class="ident">s</span>.<span class="ident">ast</span>().<span class="ident">ident</span>,
                                        <span class="ident">v</span>.<span class="ident">ast</span>().<span class="ident">ident</span>,
                                        <span class="ident">v</span>.<span class="ident">bindings</span>().<span class="ident">len</span>(),
                                        <span class="kw">if</span> <span class="ident">v</span>.<span class="ident">bindings</span>().<span class="ident">len</span>() <span class="op">!</span><span class="op">=</span> <span class="number">1</span> { <span class="string">&quot;s&quot;</span> } <span class="kw">else</span> { <span class="string">&quot;&quot;</span> }
                                    )
                                ));
                            }
                        };
                        <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="macro">quote!</span>(#<span class="ident">bi</span>));
                    }
                }
                <span class="kw">for</span> <span class="ident">bi</span> <span class="kw">in</span> <span class="ident">v</span>.<span class="ident">bindings</span>() {
                    <span class="kw">let</span> <span class="ident">id</span> <span class="op">=</span> <span class="ident">bi</span>.<span class="ident">ast</span>().<span class="ident">ident</span>.<span class="ident">as_ref</span>();
                    <span class="kw">if</span> <span class="ident">id</span>.<span class="ident">is_some</span>() <span class="op">&amp;&amp;</span> <span class="ident">path</span>.<span class="ident">is_ident</span>(<span class="ident">id</span>.<span class="ident">unwrap</span>()) {
                        <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="macro">quote!</span>(#<span class="ident">bi</span>));
                    }
                }
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::new</span>(
                    <span class="ident">arg</span>.<span class="ident">span</span>(),
                    <span class="kw-2">&amp;</span><span class="macro">format!</span>(
                        <span class="string">&quot;Couldn&#39;t find field `{:?}` in `{}::{}`&quot;</span>,
                        <span class="ident">path</span>,
                        <span class="ident">s</span>.<span class="ident">ast</span>().<span class="ident">ident</span>,
                        <span class="ident">v</span>.<span class="ident">ast</span>().<span class="ident">ident</span>
                    )
                ));
            }
            <span class="kw-2">ref</span> <span class="ident">arg</span> <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::new</span>(
                    <span class="ident">arg</span>.<span class="ident">span</span>(),
                    <span class="string">&quot;Invalid argument to fail attribute!&quot;</span>
                ));
            },
        });
        <span class="kw">let</span> <span class="ident">args</span> <span class="op">=</span> <span class="ident">args</span>.<span class="ident">collect</span>::<span class="op">&lt;</span><span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="kw">_</span><span class="op">&gt;</span>, <span class="kw">_</span><span class="op">&gt;</span><span class="op">&gt;</span>()<span class="question-mark">?</span>;

        <span class="kw">let</span> <span class="ident">pat</span> <span class="op">=</span> <span class="ident">v</span>.<span class="ident">pat</span>();
        <span class="ident">tokens</span>.<span class="ident">extend</span>(<span class="macro">quote!</span>(#<span class="ident">pat</span> <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="macro">write!</span>(<span class="ident">f</span>, #<span class="ident">format_string</span> #(, #<span class="ident">args</span>)<span class="kw-2">*</span>) }));
    }
    <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="ident">tokens</span>))
}

<span class="kw">fn</span> <span class="ident">find_error_msg</span>(<span class="ident">attrs</span>: <span class="kw-2">&amp;</span>[<span class="ident">syn::Attribute</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">syn::MetaList</span><span class="op">&gt;</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">error_msg</span> <span class="op">=</span> <span class="prelude-val">None</span>;
    <span class="kw">for</span> <span class="ident">attr</span> <span class="kw">in</span> <span class="ident">attrs</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="ident">meta</span>) <span class="op">=</span> <span class="ident">attr</span>.<span class="ident">parse_meta</span>() {
            <span class="kw">if</span> <span class="ident">meta</span>.<span class="ident">path</span>().<span class="ident">is_ident</span>(<span class="string">&quot;fail&quot;</span>) {
                <span class="kw">if</span> <span class="ident">error_msg</span>.<span class="ident">is_some</span>() {
                    <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::new</span>(
                        <span class="ident">meta</span>.<span class="ident">span</span>(),
                        <span class="string">&quot;Cannot have two display attributes&quot;</span>
                    ));
                } <span class="kw">else</span> {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="ident">syn::Meta::List</span>(<span class="ident">list</span>) <span class="op">=</span> <span class="ident">meta</span> {
                        <span class="ident">error_msg</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">list</span>);
                    } <span class="kw">else</span> {
                        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::new</span>(
                            <span class="ident">meta</span>.<span class="ident">span</span>(),
                            <span class="string">&quot;fail attribute must take a list in parentheses&quot;</span>
                        ));
                    }
                }
            }
        }
    }
    <span class="prelude-val">Ok</span>(<span class="ident">error_msg</span>)
}

<span class="kw">fn</span> <span class="ident">is_backtrace</span>(<span class="ident">bi</span>: <span class="op">&amp;&amp;</span><span class="ident">synstructure::BindingInfo</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
    <span class="kw">match</span> <span class="ident">bi</span>.<span class="ident">ast</span>().<span class="ident">ty</span> {
        <span class="ident">syn::Type::Path</span>(<span class="ident">syn::TypePath</span> {
            <span class="ident">qself</span>: <span class="prelude-val">None</span>,
            <span class="ident">path</span>: <span class="ident">syn::Path</span> {
                <span class="ident">segments</span>: <span class="kw-2">ref</span> <span class="ident">path</span>, ..
            },
        }) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">path</span>.<span class="ident">last</span>().<span class="ident">map_or</span>(<span class="bool-val">false</span>, <span class="op">|</span><span class="ident">s</span><span class="op">|</span> {
            <span class="ident">s</span>.<span class="ident">ident</span> <span class="op">=</span><span class="op">=</span> <span class="string">&quot;Backtrace&quot;</span> <span class="op">&amp;&amp;</span> <span class="ident">s</span>.<span class="ident">arguments</span>.<span class="ident">is_empty</span>()
        }),
        <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="bool-val">false</span>,
    }
}

<span class="kw">fn</span> <span class="ident">is_cause</span>(<span class="ident">bi</span>: <span class="op">&amp;&amp;</span><span class="ident">synstructure::BindingInfo</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">found_cause</span> <span class="op">=</span> <span class="bool-val">false</span>;
    <span class="kw">for</span> <span class="ident">attr</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">bi</span>.<span class="ident">ast</span>().<span class="ident">attrs</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Ok</span>(<span class="ident">meta</span>) <span class="op">=</span> <span class="ident">attr</span>.<span class="ident">parse_meta</span>() {
            <span class="kw">if</span> <span class="ident">meta</span>.<span class="ident">path</span>().<span class="ident">is_ident</span>(<span class="string">&quot;cause&quot;</span>) {
                <span class="kw">if</span> <span class="ident">found_cause</span> {
                    <span class="macro">panic!</span>(<span class="string">&quot;Cannot have two `cause` attributes&quot;</span>);
                }
                <span class="ident">found_cause</span> <span class="op">=</span> <span class="bool-val">true</span>;
            }
            <span class="kw">if</span> <span class="ident">meta</span>.<span class="ident">path</span>().<span class="ident">is_ident</span>(<span class="string">&quot;fail&quot;</span>) {
                <span class="kw">if</span> <span class="kw">let</span> <span class="ident">syn::Meta::List</span>(<span class="kw-2">ref</span> <span class="ident">list</span>) <span class="op">=</span> <span class="ident">meta</span> {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="kw-2">ref</span> <span class="ident">pair</span>) <span class="op">=</span> <span class="ident">list</span>.<span class="ident">nested</span>.<span class="ident">first</span>() {
                        <span class="kw">if</span> <span class="kw">let</span> <span class="op">&amp;&amp;</span><span class="ident">syn::NestedMeta::Meta</span>(<span class="ident">syn::Meta::Path</span>(<span class="kw-2">ref</span> <span class="ident">path</span>)) <span class="op">=</span> <span class="ident">pair</span> {
                            <span class="kw">if</span> <span class="ident">path</span>.<span class="ident">is_ident</span>(<span class="string">&quot;cause&quot;</span>) {
                                <span class="kw">if</span> <span class="ident">found_cause</span> {
                                    <span class="macro">panic!</span>(<span class="string">&quot;Cannot have two `cause` attributes&quot;</span>);
                                }
                                <span class="ident">found_cause</span> <span class="op">=</span> <span class="bool-val">true</span>;
                            }
                        }
                    }
                }
            }
        }
    }
    <span class="ident">found_cause</span>
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_failure_derive" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>